import fcntl

from pyxp.fields import Int

SOUND_MIXER_READ_DEVMASK = 0x80044DFE
MIXER_READ  = 0x80044D00
MIXER_WRITE = 0xC0044D00

mod = 0

mixers = ('vol', 'bass', 'treble', 'synth', 'pcm', 'speaker',
          'line', 'mic', 'cd', 'mix', 'pcm2', 'rec', 'igain',
          'ogain', 'line1', 'line2', 'line3', 'dig1', 'dig2',
          'dig3', 'phin', 'phout', 'video', 'radio', 'monitor')
mixerfd = open('/dev/mixer')
res = fcntl.ioctl(mixerfd, SOUND_MIXER_READ_DEVMASK, '    ')
mask = Int(4).decode(res, 0)

def findmixer(name):
    for i, mixer in enumerate(mixers):
        if (1 << i) & mask and mixer == name:
            return i

def getlevel(name):
    mixer = findmixer(name);
    res = fcntl.ioctl(mixerfd, MIXER_READ + mixer, '  ')
    return (ord(res[0]) + ord(res[1])) / 2

def setlevel(name, level):
    mixer = findmixer(name);
    fcntl.ioctl(mixerfd, MIXER_WRITE + mixer,
                chr(level & 0x7f) * 2 + '\0\0')

# vim:se sts=4 sw=4 et:

